/*
 * Copyright (c) 2004 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: flip_roller.c,v 1.4 2004/05/18 03:49:36 zinnia Exp $
 */
#include "sps.h"

// $B$A$c$s$H$&$4$-$^$;$s(B _|$B!1(B|$B!{(B

static gboolean Process(SPS_Flip_Parameter* param)
{
#ifdef USE_OPENGL
	int x;
	const int ms = 1000;
	const int window = 200;
	x = display->w - (param->tick_current - param->tick_begin) *
		display->w / ms;
	if(x <= 0) return FALSE;

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//	SPS_Scene_Draw(param->scene_after);
//	SPS_Draw_Parameter param;
//	SPS_Scene_Draw_Generic(param->scene_after, SPS_


	glBlendFunc(GL_ONE, GL_ZERO);
	glBegin(GL_TRIANGLE_STRIP);
	glColor4d(0.0, 0.0, 0.0, 0.0);
	glVertex2i(0, 0);
	glVertex2i(x - window, 0);
	glVertex2i(0, display->h);
	glVertex2i(x - window, display->h);
	glEnd();

//	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
/*	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	glBegin(GL_TRIANGLE_STRIP);
	glColor4d(0.0, 0.0, 0.0, 0.0);
	glVertex2i(x - window, 0);
	glColor4d(0.0, 0.0, 1.0, 1.0);
	glVertex2i(x, 0);
	glColor4d(0.0, 0.0, 0.0, 0.0);
	glVertex2i(x - window, display->h);
	glColor4d(0.0, 0.0, 1.0, 1.0);
	glVertex2i(x, display->h);
	glEnd();*/

/*	glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_DST_ALPHA);
	SPS_Scene_Draw(param->scene_before);*/

	return TRUE;
#else
	return FALSE;
#endif
}

SPS_Flip_Vector roller_vector = {
	TRUE, // require_opengl
	"Roller", // name
	"Roller effect.", // description
	TRUE, // disappear
	TRUE, // appear
	Process,
};

	
